export function $classOf(arg: any): any;
export function $isString(arg: any): arg is string;
export function $isNumber(arg: any): arg is number;
export function $isObject(arg: any): arg is Record<string, any>;
export const $isArray: (arg: any) => arg is any[];
export function $in(key: any, ref: any): boolean;
export function $get(ref: any, ...keys: string[]): any;
export function $eq(x: any, y: any): boolean;
export const $: {
    <T extends keyof HTMLElementTagNameMap>(config: $Config & $TConfig<T>, namespace?: string): HTMLElementTagNameMap[T];
    <T_1 extends keyof SVGElementTagNameMap>(config: $Config & $TConfig<T_1>, namespace?: string): SVGElementTagNameMap[T_1];
    <E extends HTMLElement>(config: $Config & $EConfig<E>, namespace?: string): E;
    <E_1 extends SVGElement>(config: $Config & $EConfig<E_1>, namespace?: string): E_1;
};
export const $$: {
    <T extends keyof HTMLElementTagNameMap>(x: T, a?: $Attributes, p?: $Properties, ...i: $Item[]): HTMLElementTagNameMap[T];
    <T_1 extends keyof SVGElementTagNameMap>(x: T_1, a?: $Attributes, p?: $Properties, ...i: $Item[]): SVGElementTagNameMap[T_1];
    <E extends HTMLElement>(x: E, a?: $Attributes, p?: $Properties, ...i: $Item[]): E;
    <E_1 extends SVGElement>(x: E_1, a?: $Attributes, p?: $Properties, ...i: $Item[]): E_1;
};
export function $a(href: string, ...i: $Item[]): HTMLElement;
export function $css(style: $CSS, splitter?: string): string;
export function $highlight(pattern: RegExp, highlighters: ((chunk: string, index: number) => $Item)[], innerText: string): $Item[];
export const $highlightJs: (innerText?: string | undefined) => $Item[];
export function $locale(locales: Record<string, Record<string, string | Record<string, string>>>, defaultLanguage: string, languages?: readonly string[]): (text?: string | undefined, version?: string | undefined) => string;
export type $Attributes = Record<string, string | number | boolean>;
export type $Properties = Record<string, any>;
export type $Item = Node | string | number | $Config;
export type $Tag = keyof HTMLElementTagNameMap | keyof SVGElementTagNameMap;
export type $Element = HTMLElement | SVGElement;
export type $Config = {
    t?: $Tag;
    e?: $Element;
    a?: $Attributes;
    p?: $Properties;
    i?: $Item[];
};
export type $TConfig<T> = {
    t: T;
};
export type $EConfig<E> = {
    e: E;
};
export type $CSSRules = {
    [attributeOrSelector: string]: string | number | $CSSRules;
};
export type $CSS = {
    [selector: string]: $CSSRules;
};
